#!/bin/sh -ex
#
# train1.sh
#
# First training on SPINE data, from bn-derived alignment.
# 2000-08-02 dpwe@icsi.berkeley.edu
# $Header: $

PFROOT=train-rand2
FTR=plp12
FTRWIDTH=13
DELTAORDER=1
IPWIDTH=`expr $FTRWIDTH \* \( 1 + $DELTAORDER \)`

TRNTAG=plp12dO-aBN

PFILE=$PFROOT-$FTR.pf
NORMFILE=$PFROOT-$FTR.norms
TARGETS=$PFROOT-$FTR-bn.ilab

CW=9
CWC=`expr $CW / 2`
IUS=`expr $CW \* $IPWIDTH`
HUS=1000
OUS=54

TOTSENTS=15044
CVSENTS=500
TRSENTS=`expr $TOTSENTS - $CVSENTS`

qnstrn cpu=host \
	\
	ftr1_file=$PFILE \
	ftr1_width=$FTRWIDTH \
	ftr1_ftr_count=$IPWIDTH \
	ftr1_window_len=$CW \
	ftr1_window_offset=0 \
	ftr1_norm_mode=online \
	ftr1_norm_file=$NORMFILE \
	ftr1_delta_order=$DELTAORDER \
	\
	hardtarget_file=$TARGETS \
	hardtarget_format=ilab \
	hardtarget_window_offset=$CWC \
	window_extent=$CW \
	\
	cv_sent_start=0 \
	cv_sent_count=$CVSENTS \
	train_sent_start=$CVSENTS \
	train_sent_count=$TRSENTS \
	\
	mlp3_input_size=$IUS \
	mlp3_hidden_size=$HUS \
	mlp3_output_size=$OUS \
	mlp3_bunch_size=16 \
	\
	out_weight_file=net-${TRNTAG}.wts \
	log_weight_file=log-${TRNTAG}-%e.wts \
	log_file=${TRNTAG}.log 

