#!/usr/local/bin/perl5
 
#
# efsg.pm: utility routines for efsg building
#
# Written by J. Eric Fosler-Lussier (fosler@icsi.berkeley.edu)
#
# $Header: /u/drspeech/src/lexicon/grapheme2phoneme/gen_efsg/RCS/efsg_dict.pm,v 1.3 1998/10/19 17:01:44 fosler Exp $

package efsg_dict;
use drspeech;
use onward_fsg;

# new(): generic new operator for blessing
sub new {
    my $this = shift;
    my $class = ref($this) || $this;
    my $self = {};
    bless $self, $class;
    return $self;
}

sub set_dictionary {
    my $self=shift;
    my $dictionary=shift;

    $self->{"dictionary"}=$dictionary;
}

sub buildfsg {
    my $self=shift;
    my $w=shift;
    my $currentstate=0;
    my $dictionary=$self->{"dictionary"};
    my $print_pronv=$self->{"print_pronv"};

    my $total=0;
    my @secondstate=();
    my @dictentries;
    my $fsg=new onward_fsg();
    my $i;

    @dictentries=@{$dictionary->{$w}};

    for ($i=0;$i<=$#dictentries;$i++) {
	$secondstate[$i]=$currentstate+$total+1;
	$total+=($#{$dictentries[$i]}-1);
    }
    $finalstate=$currentstate+$total+1;
    for ($i=0;$i<=$#dictentries;$i++) {
	if ($print_pronv) {
	    $fsg->addtrans($currentstate,
			   ($#{$dictentries[$i]}==1)?$finalstate:$secondstate[$i],
			   $dictentries[$i]->[0],
			   $dictentries[$i]->[1],
			   "($i)");
	} else {
	    $fsg->addtrans($currentstate,
			   ($#{$dictentries[$i]}==1)?$finalstate:$secondstate[$i],
			   $dictentries[$i]->[0],
			   $dictentries[$i]->[1]);
	}
    }
    
    $currentstate++;
    for ($i=0;$i<=$#dictentries;$i++) {
	@entry=@{$dictentries[$i]};
	for($j=2;$j<$#entry;$j++) {
	    $fsg->addtrans($currentstate,
			   $currentstate+1,
			   1.0,
			   $entry[$j]);
	    $currentstate++;
	}
	if ($#entry>1) {
	    $fsg->addtrans($currentstate,
			   $finalstate,
			   1.0,
			   $entry[$j]);
	    $currentstate++;
	}
    }
    $fsg->settrans($currentstate,[]);
    return $fsg;
}
    

    
    

1;
